/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefService A service is a representation of a function to a network that makes the function discoverable, registerable, remotely controllable by other devices in the network. A service can represent one or more functions. A Service is offered by a device that wants (a certain set of) its function(s) to be discoverable, registerable, remotely controllable by other devices in the network. A Service must specify the device that is offering the service and the function(s) to be represented.
type SarefService interface {
	owl.Thing
	sarefIsOfferedByMultipleSarefDevice
	sarefRepresentsMultipleSarefFunction
	IsSarefService() bool // indicates base class
}

// sSarefService A service is a representation of a function to a network that makes the function discoverable, registerable, remotely controllable by other devices in the network. A service can represent one or more functions. A Service is offered by a device that wants (a certain set of) its function(s) to be discoverable, registerable, remotely controllable by other devices in the network. A Service must specify the device that is offering the service and the function(s) to be represented.
type sSarefService struct {
	propCommon
	propSarefIsOfferedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice
	propSarefRepresentsBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction
}

// NewSarefService creates a new SarefService
func (mod *Model) NewSarefService(iri string) (ret SarefService, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefService{}
	pc := propCommon{iri: iri, typ: "SarefService", model: mod}
	res.propCommon = pc
	mod.addSarefService(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefService) makeMaps() {
	res.sarefIsOfferedBy = make(map[string]SarefDevice)
	res.sarefRepresents = make(map[string]SarefFunction)
	return
}

// addSarefService adds SarefService to model
func (mod *Model) addSarefService(res SarefService) {
	mod.mSarefService[res.IRI()] = res
	mod.mThing[res.IRI()] = res
	return
}

// SarefService returns all resources with given prefix
func (mod *Model) SarefService(prefix string) (res []SarefService) {
	for i := range mod.mSarefService {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefService[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefService) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#isOfferedBy":
		if v, ok := obj.(SarefDevice); ok {
			res.DelSarefIsOfferedBy(v)
		}
	case "https://w3id.org/saref#represents":
		res.propSarefRepresentsBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.removeObject(obj)
	default:
	}
	return
}

// isSarefService indicates base class
func (res *sSarefService) IsSarefService() bool {
	return true
}

// SetSarefIsOfferedBy is setter of A relationship between a service and a device that offers the service
func (res *sSarefService) SetSarefIsOfferedBy(in []SarefDevice) (err error) {
	temp := res.sarefIsOfferedBy
	res.sarefIsOfferedBy = make(map[string]SarefDevice)
	for i := range temp {
		temp[i].DelSarefOffers(res)
	}
	err = res.AddSarefIsOfferedBy(in...)
	return
}

// AddSarefIsOfferedBy adds A relationship between a service and a device that offers the service
func (res *sSarefService) AddSarefIsOfferedBy(in ...SarefDevice) (err error) {
	for i := range in {
		if _, ok := res.sarefIsOfferedBy[in[i].IRI()]; !ok {
			res.sarefIsOfferedBy[in[i].IRI()] = in[i]
			in[i].AddSarefOffers(res)
		}
	}
	return
}

// DelSarefIsOfferedBy deletes A relationship between a service and a device that offers the service
func (res *sSarefService) DelSarefIsOfferedBy(in ...SarefDevice) (err error) {
	for i := range in {
		if _, ok := res.sarefIsOfferedBy[in[i].IRI()]; ok {
			delete(res.sarefIsOfferedBy, in[i].IRI())
			in[i].DelSarefOffers(res)
		}
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefService) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefService) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#isOfferedBy":
		if obj, ok := res.model.mSarefDevice[pred.Object.Term.String()]; ok {
			res.AddSarefIsOfferedBy(obj)
		}
	case "https://w3id.org/saref#represents":
		res.propSarefRepresentsBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.init(res.model, pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefService) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#Service", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefService) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefIsOfferedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice.toGraph(node, g)
	res.propSarefRepresentsBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefService) String() (ret string) {
	ret = res.iri + " " + "SarefService\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefService) propsString() (ret string) {
	ret = ""
	ret += res.propSarefIsOfferedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice.String()
	ret += res.propSarefRepresentsBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.String()
	return
}


